#ifndef SCIRPT_LEXER_H
#define SCIRPT_LEXER_H

#include "scirpt/token.h"

typedef struct ScirptLexer ScirptLexer;

ScirptLexer* scirpt_lexer_new(const char* text, size_t text_length);
void scirpt_lexer_delete(ScirptLexer* lexer);
ScirptToken scirpt_lexer_next(ScirptLexer* lexer);

#endif
